--
-- kopaczka do ziemniakow
-- @author: Burner
--

kopaczka = {};

function kopaczka.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Trailer, specializations);
end;

function kopaczka:load(xmlFile)
    self.wasToFast = false;
	self.isTurnedOn = false;
	self.isLowered = false;
	self.ziemniaki = {};
    local i = 0;
    while true do
        local namei = string.format("vehicle.ziemniaki.ziemniaki(%d)", i);
		local nodei = Utils.indexToObject(self.components, getXMLString(xmlFile, namei .. "#index"));
		if nodei == nil then
			break;
		end; 
        Utils.loadParticleSystem(xmlFile, self.ziemniaki, namei, nodei, false, nil, self.baseDirectory)		
		Utils.setEmittingState(self.ziemniaki,false)
		self.particleSystemdisableTime = 0;
		i = i +1;		
    end;
	local workSound = getXMLString(xmlFile, "vehicle.workSound#file");
	self.soundTest = workSound;
    if workSound ~= nil and workSound ~= "" then
        workSound = Utils.getFilename(workSound, self.baseDirectory);
        self.workSound = createSample("workSound");
        self.workSoundEnabled = false;
        loadSample(self.workSound, workSound, false);
        self.workSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.workSound#pitchOffset"), 1);
        self.workSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.workSound#volume"), 1);
    end;
end;

function kopaczka:update(dt)
	if self:getIsActiveForInput() then
        if InputBinding.hasEvent(InputBinding.TOGGLEKOPACZKA) then
            self.isTurnedOn = not self.isTurnedOn;
        end;
        if InputBinding.hasEvent(InputBinding.LOWER_IMPLEMENT) then
           self.isLowered = not self.isLowered;
		end;
    end;
	self.wasToFast = false;
	if self:getIsActive() then
		if self.isTurnedOn then
			if not self.workSoundEnabled and self:getIsActiveForSound() then
	            playSample(self.workSound, 0, self.workSoundVolume, 0);
	            setSamplePitch(self.workSound, self.workSoundPitchOffset);
	            self.workSoundEnabled = true;
	        end;
			if self.isLowered then
				local toFast = self:doCheckSpeedLimit() and self.attacherVehicle.lastSpeed*3600 > 20;
				if not toFast then				
					local area = 0;
					for k, cuttingArea in pairs(self.cuttingAreas) do
						local x,y,z = getWorldTranslation(cuttingArea.start);
						local x1,y1,z1 = getWorldTranslation(cuttingArea.width);
						local x2,y2,z2 = getWorldTranslation(cuttingArea.height);
						Utils.updateFruitCutShortArea(FruitUtil.FRUITTYPE_POTATO, x, z, x1, z1, x2, z2, 1);									
						local area = Utils.cutFruitArea(FruitUtil.FRUITTYPE_POTATO, x, z, x1, z1, x2, z2, 1);
						if area > 0 then
							Utils.updateFruitCutLongArea(FruitUtil.FRUITTYPE_POTATO, x, z, x1, z1, x2, z2, 1, true);
							self.particleSystemdisableTime = self.time + 400;
							Utils.setEmittingState(self.ziemniaki, true)	 
						end;
					end;							
				end;
				self.wasToFast = toFast;
			end;
		else
			if self.workSoundEnabled then
		        stopSample(self.workSound);
		        self.workSoundEnabled = false;
			end;
		end;
	end;
	if self.time > self.particleSystemdisableTime then
		Utils.setEmittingState(self.ziemniaki, false);
	end;
end;

function kopaczka:mouseEvent(posX, posY, isDown, isUp, button)
end;

function kopaczka:keyEvent(unicode, sym, modifier, isDown)
end;

function kopaczka:draw()
	if self.isTurnedOn then
		g_currentMission:addHelpButtonText(g_i18n:getText("turnOffKopaczka"), InputBinding.TOGGLEKOPACZKA);	
    else
		g_currentMission:addHelpButtonText(g_i18n:getText("turnOnKopaczka"), InputBinding.TOGGLEKOPACZKA);	
    end;
	if self.attacherVehicle.lastSpeed*3600 > 21 and self.isTurnedOn and self.isLowered then
		g_currentMission:addWarning(g_i18n:getText("Dont_drive_to_fast") .. "\n" .. string.format(g_i18n:getText("Cruise_control_levelN"), "1", InputBinding.getKeyNamesOfDigitalAction(InputBinding.SPEED_LEVEL1)), 0.07+0.022, 0.019+0.029);
	end;
end;

function kopaczka:onAttach()
end; 	

function kopaczka:onDetach()
	self.isTurnedOn = false;
	self.isLowered = false;
	if self.workSoundEnabled then
		stopSample(self.workSound);
		self.workSoundEnabled = false;
	end;
end;

function kopaczka:onDeactivate()
    self.isTurnedOn = false;
end;

function kopaczka:delete()
	if self.workSoundEnabled then
		stopSample(self.workSound);
		self.workSoundEnabled = false;
	end;
end;

function kopaczka:onLeave()
end;